/// <reference types="node" />
import { EventEmitter } from 'events';
declare type Idrefs = Iterable<string> | ((idrefs: Iterable<string>) => Iterable<string>);
declare type Id = {
    name: string;
    value: string;
    next?: Include;
};
declare type Include = (HTMLElement: any, id: Id) => boolean;
declare type Scope = {
    [key: string]: string;
};
declare type Options = {
    idrefs?: Idrefs;
    include?: Include;
    prefix?: string;
    scope?: Scope;
};
export default class Scoper extends EventEmitter {
    private idrefs;
    private includes;
    private includer;
    private prefix;
    private scope;
    static scopeIds: typeof scopeIds;
    static scopeOwnIds: typeof scopeOwnIds;
    constructor(_options?: Options);
    private generateId;
    private getIdrefs;
    scopeOwnIds<T extends HTMLElement>(element: T, _options?: Options): T;
    scopeIds<T extends HTMLElement>(element: T, _options?: Options): T;
}
export declare function scopeIds(el: HTMLElement, options?: Options): HTMLElement;
export declare function scopeOwnIds(el: HTMLElement, options?: Options): HTMLElement;
export {};
