import 'core-js/modules/es6.string.iterator';
import 'core-js/modules/es6.array.from';
import 'core-js/modules/es6.regexp.split';
import 'core-js/modules/es7.symbol.async-iterator';
import 'core-js/modules/es6.symbol';
import 'core-js/modules/web.dom.iterable';
import 'core-js/modules/es6.array.iterator';
import 'core-js/modules/es6.object.keys';
import 'core-js/modules/es7.array.includes';
import 'core-js/modules/es6.string.includes';
import 'core-js/modules/es6.function.name';
import { EventEmitter } from 'events';

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    var ownKeys = Object.keys(source);

    if (typeof Object.getOwnPropertySymbols === 'function') {
      ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
        return Object.getOwnPropertyDescriptor(source, sym).enumerable;
      }));
    }

    ownKeys.forEach(function (key) {
      _defineProperty(target, key, source[key]);
    });
  }

  return target;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  }
}

function _iterableToArray(iter) {
  if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance");
}

// execute the `include` predicate(s), threading the `next` parameter through
// them so that an override can delegate to the function it's overriding
//
// see also:
//
//   - https://github.com/koajs/compose
//   - https://github.com/JeffRMoore/brigade
//   - https://gist.github.com/darrenscerri/5c3b3dcbe4d370435cfa
var Pipeline =
/*#__PURE__*/
function () {
  function Pipeline(invoker, _options) {
    _classCallCheck(this, Pipeline);

    var options = _options || {};
    var defaultValue = options.defaultValue;
    this.invoker = invoker;

    this.getDefaultValue = function () {
      return defaultValue;
    };
  }

  _createClass(Pipeline, [{
    key: "start",
    value: function start(_fns) {
      var fns = _toConsumableArray(_fns); // clone


      if (fns.length === 0) {
        return this.getDefaultValue;
      }

      var current = fns.pop(); // XXX current may be undefined: https://github.com/Microsoft/TypeScript/issues/10272

      if (!current) {
        return this.getDefaultValue;
      }

      var self = this;

      var fn = function fn() {
        for (var _len = arguments.length, currentArgs = new Array(_len), _key = 0; _key < _len; _key++) {
          currentArgs[_key] = arguments[_key];
        }

        function next() {
          var fn = self.start(fns);

          for (var _len2 = arguments.length, nextArgs = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
            nextArgs[_key2] = arguments[_key2];
          }

          var args = nextArgs.length === 0 ? currentArgs : nextArgs;
          return fn.apply(void 0, args);
        } // FIXME typechecking fail hack


        return self.invoker.apply(self, [current, next].concat(currentArgs));
      };

      return fn;
    }
  }]);

  return Pipeline;
}();

// in rollup

var nanoid = require('nanoid/non-secure');

var flatMap = require('lodash.flatmap'); // FIXME this is in ES201? and core-js
// the length of the random part of each scoped ID


var HASH_LENGTH = 16; // the default list of attribute names we expect to find IDs in
//
// for ARIA attributes, see: https://www.w3.org/TR/wai-aria/
//
// FIXME this isn't a complete list:
// https://developer.mozilla.org/en-US/docs/Web/HTML/Global_attributes

var DEFAULT_IDREFS = ['id', 'aria-activedescendant', 'aria-controls', 'aria-describedby', 'aria-details', 'aria-errormessage', 'aria-flowto', 'aria-labelledby', 'aria-owns', 'for']; // the default string to prepend to all generated IDs i.e. their de-facto namespace
//
// XXX not sure about exposing this as a config option as it encourages
// knowledge of and reliance on what should be an implementation detail

var DEFAULT_PREFIX = 'scoped-id'; // the base/fallback `include` predicate

function defaultInclude(el, _ref) {
  var name = _ref.name;

  if (name === 'for') {
    return el.tagName === 'LABEL';
  }

  return true;
} // instances of this class scope IDs within an element i.e. rewrite them to be
// globally unique.
//
// the main reason to instantiate this is to register event listeners. otherwise,
// if the default options are fine, the `scopeIds` method can be called on a
// default instance of this class via the exported `scopeIds` wrapper function
//
// TODO replace events.EventEmitter with a (lightweight) mixin


var Scoper =
/*#__PURE__*/
function (_EventEmitter) {
  _inherits(Scoper, _EventEmitter);

  function Scoper(_options) {
    var _this;

    _classCallCheck(this, Scoper);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Scoper).call(this));
    var options = _options || {};
    var includes = [defaultInclude];

    if (options.include) {
      includes.push(options.include);
    }

    _this.idrefs = _this.getIdrefs(options.idrefs, DEFAULT_IDREFS);
    _this.includes = includes;
    _this.scope = options.scope;

    function invoker(current, next, el, id) {
      return current(el, _objectSpread({}, id, {
        next: next
      }));
    }

    _this.includer = new Pipeline(invoker, {
      defaultValue: true
    }); // make sure it's not an empty string

    var prefix = (options.prefix || DEFAULT_PREFIX).trim();

    if (prefix && /^[a-zA-z_]/.test(prefix)) {
      _this.prefix = prefix;
    } else {
      var dump = JSON.stringify(prefix);
      console.warn("invalid prefix (".concat(dump, "): prefix must start with a character in the range /[a-zA-Z_]/"));
      _this.prefix = DEFAULT_PREFIX;
    }

    return _this;
  } // scope the supplied ID by returning a replacement that's globally unique


  _createClass(Scoper, [{
    key: "generateId",
    value: function generateId(id, prefix) {
      return "".concat(prefix, "-").concat(id, "-").concat(nanoid(HASH_LENGTH));
    } // returns the list (e.g. array) of attribute names which are examined for IDs.
    // may be overridden (via a function), in which case we pass the (cloned)
    // default list as a parameter so that it can be modified or augmented

  }, {
    key: "getIdrefs",
    value: function getIdrefs(idrefs, baseIdrefs) {
      if (typeof idrefs === 'function') {
        var clone = _toConsumableArray(baseIdrefs);

        idrefs = idrefs(clone);
      }

      return idrefs || baseIdrefs;
    } // replace IDs in the supplied element (i.e. not in its descendants) with
    // their scoped (i.e. globally unique) versions.
    //
    // returns the element for chaining

  }, {
    key: "scopeOwnIds",
    value: function scopeOwnIds(element, _options) {
      var _this2 = this;

      var options = _options || {};
      var idrefs = this.getIdrefs(options.idrefs, this.idrefs);
      var includes = options.include ? this.includes.concat(options.include) : this.includes;
      var prefix = options.prefix || this.prefix;
      var scope = options.scope || this.scope || {};
      var deltas = {};
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        var _loop = function _loop() {
          var name = _step.value;
          var oldIds = (element.getAttribute(name) || '').trim();

          if (!oldIds) {
            return "continue";
          }

          var mapped = flatMap(oldIds.split(/\s+/), function (id) {
            var include = _this2.includer.start(includes);

            if (!include(element, {
              name: name,
              value: id
            })) {
              return [];
            }

            var cached = scope[id];

            if (!cached) {
              var newId = _this2.generateId(id, prefix);

              cached = scope[id] = newId; // translated IDs should not be recycled in this scope
              // (which may be a global scope if a scope option was passed
              // to the constructor)

              scope[newId] = newId;
            }

            _this2.emit('id', element, {
              name: name,
              old: id,
              'new': cached
            });

            return cached;
          });
          var newIds = mapped.join(' ');

          if (newIds === oldIds) {
            return "continue";
          }

          element.setAttribute(name, newIds);
          deltas[name] = {
            old: oldIds,
            'new': newIds
          };
        };

        for (var _iterator = idrefs[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var _ret = _loop();

          if (_ret === "continue") continue;
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return != null) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      var names = Object.keys(deltas);

      if (names.length) {
        this.emit('ids', element, deltas);
      }

      return element;
    } // replace IDs in descendants of the supplied element (e.g. "summary-panel")
    // with scoped versions by making them globally unique (e.g.
    // "scoped-id-summary-panel-abc123")
    //
    // returns the element for chaining

  }, {
    key: "scopeIds",
    value: function scopeIds(element, _options) {
      var options = _options || {};
      var idrefs = this.getIdrefs(options.idrefs, this.idrefs);
      var scope = options.scope || this.scope || {}; // if there's a new/different scope, merge it into the options

      if (scope !== options.scope) {
        options = _objectSpread({}, options, {
          scope: scope
        });
      } // merge in the resolved idrefs: we don't need to keep resolving them
      // if `idrefs` is a callback


      if (typeof options.idrefs === 'function') {
        options = _objectSpread({}, options, {
          idrefs: idrefs
        });
      }

      var selector = Array.from(idrefs).map(function (name) {
        return "[".concat(name, "]");
      }).join(', ');
      var descendants = element.querySelectorAll(selector);
      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = descendants[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var descendant = _step2.value;
          this.scopeOwnIds(descendant, options);
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return != null) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }

      return element;
    }
  }]);

  return Scoper;
}(EventEmitter); // XXX these are here for CommonJS (because we get warnings and errors in
Scoper.scopeIds = scopeIds;
Scoper.scopeOwnIds = scopeOwnIds; // the default Scoper instance used for the `scopeIds` helper function

var SCOPER = new Scoper(); // a convenience function which provides access to the `scopeIds` method for the
// common case where a custom Scoper instance isn't needed
//
// XXX don't export this (yet), as mixing named and default exports triggers
// breakage (microbundle) or a warning (bili)

function scopeIds(el, options) {
  return SCOPER.scopeIds(el, options);
} // a convenience function which provides access to the `scopeOwnIds` method for
// the common case where a custom Scoper instance isn't needed

function scopeOwnIds(el, options) {
  return SCOPER.scopeOwnIds(el, options);
}

export default Scoper;
export { scopeIds, scopeOwnIds };
